From 5c433204cff57a615f306307281047f4d9dc6dfd Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Mon, 3 Jun 2019 23:45:10 -0400
Subject: [PATCH 06/31] initial work and dummy tests for
 SquadDetailDefinitionUpdateMessage packet; 46-bit certification encoding;
 indicating four previously unhandled SquadAction types; the squad leader is
 allowed to move around his squad

---
 .../psforever/objects/teamwork/Member.scala   |  12 +-
 .../psforever/objects/teamwork/Squad.scala    |  12 +-
 .../psforever/packet/GamePacketOpcode.scala   |   2 +-
 .../game/SquadDefinitionActionMessage.scala   |  65 ++++-
 .../SquadDetailDefinitionUpdateMessage.scala  | 195 +++++++++++++++
 .../psforever/types/CertificationType.scala   |  57 +++++
 .../services/teamwork/SquadService.scala      | 226 +++++++++---------
 .../SquadDefinitionActionMessageTest.scala    |  68 +++++-
 ...uadDetailDefinitionUpdateMessageTest.scala |  45 ++++
 .../src/main/scala/WorldSessionActor.scala    |  29 +++
 10 files changed, 582 insertions(+), 129 deletions(-)
 create mode 100644 common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
 create mode 100644 common/src/test/scala/game/SquadDetailDefinitionUpdateMessageTest.scala

diff --git a/common/src/main/scala/net/psforever/objects/teamwork/Member.scala b/common/src/main/scala/net/psforever/objects/teamwork/Member.scala
index 46d9e15f..4d3b24e8 100644
--- a/common/src/main/scala/net/psforever/objects/teamwork/Member.scala
+++ b/common/src/main/scala/net/psforever/objects/teamwork/Member.scala
@@ -7,7 +7,7 @@ class Member {
   //about the position to be filled
   private var role : String = ""
   private var orders : String = ""
-  private var restrictions : Set[CertificationType.Value] = Set()
+  private var requirements : Set[CertificationType.Value] = Set()
   //about the individual filling the position
   private var name : String = ""
   private var health : Int = 0
@@ -29,11 +29,11 @@ class Member {
     Orders
   }
 
-  def Restrictions : Set[CertificationType.Value] = restrictions
+  def Requirements : Set[CertificationType.Value] = requirements
 
-  def Restrictions_=(requirements : Set[CertificationType.Value]) = {
-    restrictions = requirements
-    Restrictions
+  def Requirements_=(req : Set[CertificationType.Value]) : Set[CertificationType.Value] = {
+    requirements = req
+    Requirements
   }
 
   def Name : String = name
@@ -73,7 +73,7 @@ class Member {
 
   def Close() : Unit = {
     role = ""
-    restrictions = Set()
+    requirements = Set()
     //about the individual filling the position
     name = ""
     health = 0
diff --git a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
index 071d8a8e..4ac3cfc2 100644
--- a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
+++ b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
@@ -14,6 +14,7 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
   private val membership : Array[Member] = Array.fill[Member](10)(new Member)
   private val availability : Array[Boolean] = Array.fill[Boolean](10)(true)
   private var listed : Boolean = false
+  private var leaderPositionIndex : Int = 0
 
   override def GUID_=(d : PlanetSideGUID) : PlanetSideGUID = GUID
 
@@ -62,8 +63,17 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
 
   def Availability : Array[Boolean] = availability
 
+  def LeaderPositionIndex : Int = leaderPositionIndex
+
+  def LeaderPositionIndex_=(position : Int) : Int = {
+    if(availability.lift(position).contains(true)) {
+      leaderPositionIndex = position
+    }
+    LeaderPositionIndex
+  }
+
   def Leader : String = {
-    membership.headOption match {
+    membership.lift(leaderPositionIndex) match {
       case Some(member) =>
         member.Name
       case None =>
diff --git a/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala b/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
index 3845c4a3..d0ab02cf 100644
--- a/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
+++ b/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
@@ -592,7 +592,7 @@ object GamePacketOpcode extends Enumeration {
     case 0xe6 => game.ReplicationStreamMessage.decode
     case 0xe7 => game.SquadDefinitionActionMessage.decode
     // 0xe8
-    case 0xe8 => noDecoder(SquadDetailDefinitionUpdateMessage)
+    case 0xe8 => game.SquadDetailDefinitionUpdateMessage.decode
     case 0xe9 => noDecoder(TacticsMessage)
     case 0xea => noDecoder(RabbitUpdateMessage)
     case 0xeb => noDecoder(SquadInvitationRequestMessage)
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
index 5b714fc8..40193730 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
@@ -2,6 +2,7 @@
 package net.psforever.packet.game
 
 import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
+import net.psforever.types.CertificationType
 import scodec.bits.BitVector
 import scodec.{Attempt, Codec, Err}
 import scodec.codecs._
@@ -15,12 +16,20 @@ import shapeless.{::, HNil}
 abstract class SquadAction(val code : Int)
 
 object SquadAction{
+  final case class DisplaySquad() extends SquadAction(0)
+
   final case class SaveSquadDefinition() extends SquadAction(3)
 
+  final case class LoadSquadDefinition() extends SquadAction(4)
+
+  final case class ListSquadDefinition(name : String) extends SquadAction(7)
+
   final case class ListSquad() extends SquadAction(8)
 
   final case class SelectRoleForYourself(state : Int) extends SquadAction(10)
 
+  final case class CancelSelectRoleForYourself(value: Long = 0) extends SquadAction(15)
+
   final case class ChangeSquadPurpose(purpose : String) extends SquadAction(19)
 
   final case class ChangeSquadZone(zone : PlanetSideZoneID) extends SquadAction(20)
@@ -33,7 +42,7 @@ object SquadAction{
 
   final case class ChangeSquadMemberRequirementsDetailedOrders(u1 : Int, orders : String) extends SquadAction(24)
 
-  final case class ChangeSquadMemberRequirementsWeapons(u1 : Int, u2 : Long) extends SquadAction(25)
+  final case class ChangeSquadMemberRequirementsCertifications(u1 : Int, certs : Set[CertificationType.Value]) extends SquadAction(25)
 
   final case class ResetAll() extends SquadAction(26)
 
@@ -58,6 +67,13 @@ object SquadAction{
   object Codecs {
     private val everFailCondition = conditional(included = false, bool)
 
+    val displaySquadCodec = everFailCondition.xmap[DisplaySquad] (
+      _ => DisplaySquad(),
+      {
+        case DisplaySquad() => None
+      }
+    )
+
     val saveSquadDefinitionCodec = everFailCondition.xmap[SaveSquadDefinition] (
       _ => SaveSquadDefinition(),
       {
@@ -65,6 +81,20 @@ object SquadAction{
       }
     )
 
+    val loadSquadDefinitionCodec = everFailCondition.xmap[LoadSquadDefinition] (
+      _ => LoadSquadDefinition(),
+      {
+        case LoadSquadDefinition() => None
+      }
+    )
+
+    val listSquadDefinitionCodec = PacketHelpers.encodedWideStringAligned(6).xmap[ListSquadDefinition] (
+      text => ListSquadDefinition(text),
+      {
+        case ListSquadDefinition(text) => text
+      }
+    )
+
     val listSquadCodec = everFailCondition.xmap[ListSquad] (
       _ => ListSquad(),
       {
@@ -79,6 +109,13 @@ object SquadAction{
       }
     )
 
+    val cancelSelectRoleForYourselfCodec = uint32.xmap[CancelSelectRoleForYourself] (
+      value => CancelSelectRoleForYourself(value),
+      {
+        case CancelSelectRoleForYourself(value) => value
+      }
+    )
+
     val changeSquadPurposeCodec = PacketHelpers.encodedWideStringAligned(6).xmap[ChangeSquadPurpose] (
       purpose => ChangeSquadPurpose(purpose),
       {
@@ -125,12 +162,14 @@ object SquadAction{
       }
     )
 
-    val changeSquadMemberRequirementsWeaponsCodec = (uint4 :: ulongL(46)).xmap[ChangeSquadMemberRequirementsWeapons] (
+    val changeSquadMemberRequirementsCertificationsCodec = (uint4 :: ulongL(46)).xmap[ChangeSquadMemberRequirementsCertifications] (
       {
-        case u1 :: u2 :: HNil => ChangeSquadMemberRequirementsWeapons(u1, u2)
+        case u1 :: u2 :: HNil =>
+          ChangeSquadMemberRequirementsCertifications(u1, CertificationType.fromEncodedLong(u2))
       },
       {
-        case ChangeSquadMemberRequirementsWeapons(u1, u2) => u1 :: u2 :: HNil
+        case ChangeSquadMemberRequirementsCertifications(u1, u2) =>
+          u1 :: CertificationType.toEncodedLong(u2) :: HNil
       }
     )
 
@@ -219,11 +258,11 @@ object SquadAction{
   * The `action` code indicates the format of the remainder data in the packet.
   * The following formats are translated; their purposes are listed:<br>
   * &nbsp;&nbsp;`(None)`<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`0 ` - UNKNOWN<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`0 ` - Display Squad<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`1 ` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`2 ` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`3 ` - Save Squad Definition<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`4 ` - UNKNOWN<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`4 ` - Load Squad Definition<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`6 ` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`8 ` - List Squad<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`9 ` - UNKNOWN<br>
@@ -251,10 +290,10 @@ object SquadAction{
   * &nbsp;&nbsp;`Long`<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`13` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`14` - UNKNOWN<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`15` - UNKNOWN<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`15` - Select this Role for Yourself<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`37` - UNKNOWN<br>
   * &nbsp;&nbsp;`String`<br>
-  * &nbsp;&nbsp;&nbsp;&nbsp;`7 ` - UNKNOWN<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`7 ` - List Squad Definition<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`19` - (Squad leader) Change Squad Purpose<br>
   * &nbsp;&nbsp;`Int :: Long`<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`12` - UNKNOWN<br>
@@ -293,16 +332,20 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
     import SquadAction.Codecs._
     import scala.annotation.switch
     ((code : @switch) match {
+      case 0 => displaySquadCodec
       case 3 => saveSquadDefinitionCodec
+      case 4 => loadSquadDefinitionCodec
+      case 7 => listSquadDefinitionCodec
       case 8 => listSquadCodec
       case 10 => selectRoleForYourselfCodec
+      case 15 => cancelSelectRoleForYourselfCodec
       case 19 => changeSquadPurposeCodec
       case 20 => changeSquadZoneCodec
       case 21 => closeSquadMemberPositionCodec
       case 22 => addSquadMemberPositionCodec
       case 23 => changeSquadMemberRequirementsRoleCodec
       case 24 => changeSquadMemberRequirementsDetailedOrdersCodec
-      case 25 => changeSquadMemberRequirementsWeaponsCodec
+      case 25 => changeSquadMemberRequirementsCertificationsCodec
       case 26 => resetAllCodec
       case 28 => autoApproveInvitationRequestsCodec
       case 31 => locationFollowsSquadLeadCodec
@@ -310,8 +353,8 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
       case 35 => cancelSquadSearchCodec
       case 40 => findLfsSoldiersForRoleCodec
       case 41 => cancelFindCodec
-      case 0 | 1 | 2 | 4 | 6 | 7 | 9 |
-           11 | 12 | 13 | 14 | 15 | 16 |
+      case 1 | 2 | 6 | 9 |
+           11 | 12 | 13 | 14 | 16 |
            17 | 18 | 29 | 30 | 33 | 36 |
            37 | 38 | 42 | 43 => unknownCodec(code)
       case _ => failureCodec(code)
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
new file mode 100644
index 00000000..291ef219
--- /dev/null
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
@@ -0,0 +1,195 @@
+// Copyright (c) 2019 PSForever
+package net.psforever.packet.game
+
+import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
+import net.psforever.types.CertificationType
+import scodec.bits.BitVector
+import scodec.{Attempt, Codec, Err}
+import scodec.codecs._
+import shapeless.HNil
+
+import scala.annotation.tailrec
+
+final case class SquadPositionDetail(is_closed : Boolean,
+                                     role : String,
+                                     detailed_orders : String,
+                                     requirements : Set[CertificationType.Value],
+                                     char_id : Long,
+                                     name : String)
+
+final case class SquadDetailDefinitionUpdateMessage(guid : PlanetSideGUID,
+                                                    unk : BitVector,
+                                                    leader_name : String,
+                                                    task : String,
+                                                    zone_id : PlanetSideZoneID,
+                                                    member_info : List[SquadPositionDetail])
+  extends PlanetSideGamePacket {
+  type Packet = SquadDetailDefinitionUpdateMessage
+  def opcode = GamePacketOpcode.SquadDetailDefinitionUpdateMessage
+  def encode = SquadDetailDefinitionUpdateMessage.encode(this)
+}
+
+object SquadPositionDetail {
+  final val Closed : SquadPositionDetail = SquadPositionDetail(is_closed = true, "", "", Set.empty, 0L, "")
+
+  private def reliableNameHash(name : String) : Long = {
+    val hash = name.hashCode.toLong
+    if(hash < 0) {
+      -1L * hash
+    }
+    else {
+      hash
+    }
+  }
+
+  def apply() : SquadPositionDetail = SquadPositionDetail(is_closed = false, "", "", Set.empty, 0L, "")
+
+  def apply(name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, "", "", Set.empty, reliableNameHash(name), name)
+
+  def apply(role : String, detailed_orders : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, Set.empty, 0L, "")
+
+  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value]) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, requirements, 0L, "")
+
+  def apply(role : String, detailed_orders : String, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, Set.empty, reliableNameHash(name), name)
+}
+
+object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefinitionUpdateMessage] {
+  final val defaultRequirements : Set[CertificationType.Value] = Set(
+    CertificationType.StandardAssault,
+    CertificationType.StandardExoSuit,
+    CertificationType.AgileExoSuit
+  )
+
+  def apply(guid : PlanetSideGUID, leader_name : String, task : String, zone_id : PlanetSideZoneID, member_info : List[SquadPositionDetail]) : SquadDetailDefinitionUpdateMessage = {
+    import scodec.bits._
+    SquadDetailDefinitionUpdateMessage(guid, hex"080000000000000000000".toBitVector, leader_name, task, zone_id, member_info)
+  }
+
+  private def memberCodec(pad : Int) : Codec[SquadPositionDetail] = {
+    import shapeless.::
+    (
+        uint8 :: //required value = 6
+        ("is_closed" | bool) :: //if all positions are closed, the squad detail menu display no positions at all
+        ("role" | PacketHelpers.encodedWideStringAligned(pad)) ::
+        ("detailed_orders" | PacketHelpers.encodedWideString) ::
+        ("char_id" | uint32L) ::
+        ("name" | PacketHelpers.encodedWideString) ::
+        ("requirements" | ulongL(46))
+      ).exmap[SquadPositionDetail] (
+      {
+        case 6 :: closed :: role :: orders :: char_id :: name :: requirements :: HNil =>
+          Attempt.Successful(
+            SquadPositionDetail(closed, role, orders, defaultRequirements ++ CertificationType.fromEncodedLong(requirements), char_id, name)
+          )
+        case data =>
+          Attempt.Failure(Err(s"can not decode a SquadDetailDefinitionUpdate member's data - $data"))
+      },
+      {
+        case SquadPositionDetail(closed, role, orders, requirements, char_id, name) =>
+          Attempt.Successful(6 :: closed :: role :: orders :: char_id :: name :: CertificationType.toEncodedLong(defaultRequirements ++ requirements) :: HNil)
+      }
+    )
+  }
+
+  private val first_member_codec : Codec[SquadPositionDetail] = memberCodec(pad = 7)
+
+  private val member_codec : Codec[SquadPositionDetail] = memberCodec(pad = 0)
+
+  private case class LinkedMemberList(member : SquadPositionDetail, next : Option[LinkedMemberList])
+
+  private def subsequent_member_codec : Codec[LinkedMemberList] = {
+    import shapeless.::
+    (
+      //disruptive coupling action (e.g., flatPrepend) necessary to allow for recursive Codec
+      ("member" | member_codec) >>:~ { _ =>
+        optional(bool, "next" | subsequent_member_codec).hlist
+      }
+      ).xmap[LinkedMemberList] (
+      {
+        case a :: b :: HNil =>
+          LinkedMemberList(a, b)
+      },
+      {
+        case LinkedMemberList(a, b) =>
+          a :: b :: HNil
+      }
+    )
+  }
+
+  private def initial_member_codec : Codec[LinkedMemberList] = {
+    import shapeless.::
+    (
+      ("member" | first_member_codec) ::
+        optional(bool, "next" | subsequent_member_codec)
+      ).xmap[LinkedMemberList] (
+      {
+        case a :: b :: HNil =>
+          LinkedMemberList(a, b)
+      },
+      {
+        case LinkedMemberList(a, b) =>
+          a :: b :: HNil
+      }
+    )
+  }
+
+  @tailrec
+  private def unlinkMemberList(list : LinkedMemberList, out : List[SquadPositionDetail] = Nil) : List[SquadPositionDetail] = {
+    list.next match {
+      case None =>
+        out :+ list.member
+      case Some(next) =>
+        unlinkMemberList(next, out :+ list.member)
+    }
+  }
+
+  private def linkMemberList(list : List[SquadPositionDetail]) : LinkedMemberList = {
+    list match {
+      case Nil =>
+        throw new Exception("")
+      case x :: Nil =>
+        LinkedMemberList(x, None)
+      case x :: xs =>
+        linkMemberList(xs, LinkedMemberList(x, None))
+    }
+  }
+
+  @tailrec
+  private def linkMemberList(list : List[SquadPositionDetail], out : LinkedMemberList) : LinkedMemberList = {
+    list match {
+      case Nil =>
+        out
+      case x :: Nil =>
+        LinkedMemberList(x, Some(out))
+      case x :: xs =>
+        linkMemberList(xs, LinkedMemberList(x, Some(out)))
+    }
+  }
+
+  implicit val codec : Codec[SquadDetailDefinitionUpdateMessage] = {
+    import shapeless.::
+    (
+      ("guid" | PlanetSideGUID.codec) ::
+        uint8 ::
+        uint4 ::
+        bits(83) :: //variable fields, but can be 0'd
+        uint(10) :: //constant = 0
+        ("leader" | PacketHelpers.encodedWideStringAligned(7)) ::
+        ("task" | PacketHelpers.encodedWideString) ::
+        ("zone_id" | PlanetSideZoneID.codec) ::
+        uint(23) :: //constant = 4983296
+        optional(bool, "member_info" | initial_member_codec)
+      ).exmap[SquadDetailDefinitionUpdateMessage] (
+      {
+        case guid :: _ :: _ :: _ :: _ :: leader :: task :: zone :: _ :: Some(member_list) :: HNil =>
+          Attempt.Successful(SquadDetailDefinitionUpdateMessage(guid, leader, task, zone, unlinkMemberList(member_list)))
+        case data =>
+          Attempt.failure(Err(s"can not get squad detail definition from data $data"))
+      },
+      {
+        case SquadDetailDefinitionUpdateMessage(guid, unk, leader, task, zone, member_list) =>
+          Attempt.Successful(guid :: 132 :: 8 :: unk.take(83) :: 0 :: leader :: task :: zone :: 4983296 :: Some(linkMemberList(member_list.reverse)) :: HNil)
+      }
+    )
+  }
+}
diff --git a/common/src/main/scala/net/psforever/types/CertificationType.scala b/common/src/main/scala/net/psforever/types/CertificationType.scala
index ea4ca3ab..99afa33c 100644
--- a/common/src/main/scala/net/psforever/types/CertificationType.scala
+++ b/common/src/main/scala/net/psforever/types/CertificationType.scala
@@ -3,6 +3,8 @@ package net.psforever.types
 
 import net.psforever.packet.PacketHelpers
 import scodec.codecs._
+
+import scala.annotation.tailrec
 /**
   * An `Enumeration` of the available certifications.<br>
   * <br>
@@ -76,4 +78,59 @@ object CertificationType extends Enumeration {
   = Value
 
   implicit val codec = PacketHelpers.createEnumerationCodec(this, uint8L)
+
+  /**
+    * Certifications are often stored, in object form, as a 46-member collection.
+    * Encode a subset of certification values for packet form.
+    * @see `ChangeSquadMemberRequirementsCertifications`
+    * @see `changeSquadMemberRequirementsCertificationsCodec`
+    * @param certs the certifications, as a sequence of values
+    * @return the certifications, as a single value
+    */
+  def toEncodedLong(certs : Set[CertificationType.Value]) : Long = {
+    certs
+      .map{ cert => math.pow(2, cert.id).toLong }
+      .foldLeft(0L)(_ + _)
+  }
+
+  /**
+    * Certifications are often stored, in packet form, as an encoded little-endian `46u` value.
+    * Decode a representative value into a subset of certification values.
+    * @see `ChangeSquadMemberRequirementsCertifications`
+    * @see `changeSquadMemberRequirementsCertificationsCodec`
+    * @see `fromEncodedLong(Long, Iterable[Long], Set[CertificationType.Value])`
+    * @param certs the certifications, as a single value
+    * @return the certifications, as a sequence of values
+    */
+  def fromEncodedLong(certs : Long) : Set[CertificationType.Value] = {
+    recursiveFromEncodedLong(
+      certs,
+      CertificationType.values.map{ cert => math.pow(2, cert.id).toLong }.toSeq.sorted
+    )
+  }
+
+  /**
+    * Certifications are often stored, in packet form, as an encoded little-endian `46u` value.
+    * Decode a representative value into a subset of certification values
+    * by repeatedly finding the partition point of values less than a specific one,
+    * providing for both the next lowest value (to subtract) and an index (of a certification).
+    * @see `ChangeSquadMemberRequirementsCertifications`
+    * @see `changeSquadMemberRequirementsCertificationsCodec`
+    * @see `fromEncodedLong(Long)`
+    * @param certs the certifications, as a single value
+    * @param splitList the available values to partition
+    * @param out the accumulating certification values;
+    *            defaults to an empty set
+    * @return the certifications, as a sequence of values
+    */
+  @tailrec
+  private def recursiveFromEncodedLong(certs : Long, splitList : Iterable[Long], out : Set[CertificationType.Value] = Set.empty) : Set[CertificationType.Value] = {
+    if(certs == 0 || splitList.isEmpty) {
+      out
+    }
+    else {
+      val (less, _) = splitList.partition(_ <= certs)
+      recursiveFromEncodedLong(certs - less.last, less, out ++ Set(CertificationType(less.size - 1)))
+    }
+  }
 }
